(* CDF Properties based on Basic probability by Khazanie 

loadPath := "/nfs/thesis/o/o_hasan/hol/cont_prob_dist/miller" ::
!loadPath;

app load ["HolKernel", "Parse", "boolLib", "bossLib", "arithmeticTheory",
     "pred_setTheory", "listTheory", "sequenceTheory", "state_transformerTheory",
     "probabilityTheory", "formalizeUseful", "extra_numTheory", "combinTheory",
     "pairTheory", "realTheory", "realLib", "extra_boolTheory", "jrhUtils",
     "extra_pred_setTheory", "prob_algebraTheory", "probTheory", "realSimps",
     "extra_realTheory", "extra_pred_setTools", "measureTheory", "numTheory",
     "simpLib", "prob_extraTheory", "probTools", "prob_extraTools", "pred_setLib",
     "subtypeTheory", "probdec_interTheory", "seqTheory", "std_unifTheory"]; 

*)


open HolKernel Parse boolLib bossLib arithmeticTheory pred_setTheory
     listTheory sequenceTheory state_transformerTheory
     probabilityTheory formalizeUseful extra_numTheory combinTheory
     pairTheory realTheory realLib extra_boolTheory jrhUtils
     extra_pred_setTheory prob_algebraTheory probTheory realSimps
     extra_realTheory extra_pred_setTools measureTheory numTheory
     simpLib prob_extraTheory probTools prob_extraTools pred_setLib
     subtypeTheory seqTheory std_unifTheory limTheory;


val _ = new_theory "cdf";


val CDF_def = Define
        `CDF (f: (num -> bool) -> real) (x:real) =
		prob bern {s | f s <= x}`;

val CDF_in_events_bern_def = Define
	`CDF_in_events_bern (f: (num -> bool) -> real) (x:real) = 
		{s | f s <= x} IN events bern`;


(*
g `!x. CDF (std_unif_cont) x = (if (x < 0) then 0 else
                        (if (x < 1) then x else 1))`;
e (RW_TAC std_ss [CDF_def, CDF_UNIF_CONT]);

g `!x a b. (a < b) ==>
        (CDF (uniform_cont a b) x = 
                (if (x <= a) then 0 else
                        (if (x <= b) then (x - a) / (b - a) else 1)))`;
e (RW_TAC std_ss [CDF_def,CDF_UNIFORM_CONT]);
*)


val REAL_SUB_ASSOC = store_thm
  ("REAL_SUB_ASSOC",
  (--`! (a: real) b c. a - b - c = a - (b + c)` --),
	REAL_ARITH_TAC);

val PROB_COUNTABLE_DECREASING = store_thm
  ("PROB_COUNTABLE_DECREASING",
  (--`!s f p. prob_space p /\ 
        (f:num -> (num -> bool) -> bool) IN (UNIV -> events p) /\
       (f 0 = UNIV) /\ (!n. f (SUC n) SUBSET f n) /\
       (s = BIGINTER (IMAGE f UNIV)) ==>
       prob p o f --> prob p s`--),
  RW_TAC std_ss [IN_FUNSET, IN_UNIV] THEN
  KNOW_TAC `prob p o (f:num -> (num -> bool) -> bool) = 
	(\n. 1 - sum (0, n) (prob p o (\m. f m DIFF f (SUC m))))` THEN1
	(FUN_EQ_TAC THEN
	Induct THEN1
		RW_TAC real_ss [o_THM, sum, PROB_UNIV] THEN
	POP_ASSUM (MP_TAC o SYM) THEN
	RW_TAC arith_ss [o_THM, sum] THEN
	RW_TAC std_ss [GSYM REAL_SUB_ASSOC] THEN
	REWRITE_TAC [REAL_EQ_SUB_LADD] THEN
	ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
	MATCH_MP_TAC PROB_ADDITIVE THEN
	RW_TAC std_ss [EVENTS_DIFF] THENL [
		PSET_TAC [DISJOINT_DEF, DIFF_DEF] THEN
		REWRITE_TAC [GSYM GSPEC_F] THEN
		REWRITE_TAC [EXTENSION] THEN
		PSET_TAC [] THEN
		PROVE_TAC [],

		PSET_TAC [UNION_DEF, DIFF_DEF] THEN
		REWRITE_TAC [LEFT_OR_OVER_AND] THEN
		FULL_SIMP_TAC std_ss [] THEN
		KNOW_TAC `!x'. x' IN f (SUC x) \/ x' IN f x = x' IN f x`  THEN1
			PROVE_TAC [] THEN
		ASM_REWRITE_TAC [GSPEC_ID]]) THEN
	
  KNOW_TAC `prob p (BIGINTER (IMAGE (f:num -> (num -> bool) -> bool) UNIV)) = 
	1 - prob p (COMPL (BIGINTER (IMAGE f UNIV)))` THEN1
  	(SUFF_TAC `prob p (COMPL (BIGINTER (IMAGE (f:num -> (num -> bool) -> bool) UNIV))) = 
			1 - prob p (BIGINTER (IMAGE f UNIV))` THENL [
		FULL_SIMP_TAC std_ss [] THEN
		REAL_ARITH_TAC,

		MATCH_MP_TAC PROB_COMPL THEN
		RW_TAC std_ss [] THEN
		MATCH_MP_TAC EVENTS_COUNTABLE_INTER THEN
		RW_TAC std_ss [COUNTABLE_IMAGE_NUM] THEN
		RW_TAC std_ss [SUBSET_DEF, IN_IMAGE] THEN
		PROVE_TAC []]) THEN
  ASM_REWRITE_TAC [] THEN

  KNOW_TAC `(\n. 1 - sum (0,n) (prob p o (\m. (f:num -> (num -> bool) -> bool) m DIFF f (SUC m)))) = 
		(\n. (\n. 1) n - (\n. sum (0,n) (prob p o (\m. f m DIFF f (SUC m)))) n)` THEN1
  	RW_TAC std_ss [] THEN
  PURE_ASM_REWRITE_TAC [] THEN
  MATCH_MP_TAC SEQ_SUB THEN
  CONJ_TAC THEN1
	RW_TAC std_ss [SEQ_CONST] THEN
  REWRITE_TAC [COMPL_BIGINTER, IMAGE_IMAGE] THEN
  KNOW_TAC `(COMPL o (f:num -> (num -> bool) -> bool)) 0 = {}` THEN1
	RW_TAC std_ss [EXTENSION, IN_COMPL, IN_UNIV, NOT_IN_EMPTY] THEN
  KNOW_TAC `!n. ((COMPL o (f:num -> (num -> bool) -> bool)) n) SUBSET ((COMPL o f) (SUC n))` THEN1
	(PSET_TAC [COMPL_DEF, SUBSET_DEF] THEN
	PROVE_TAC []) THEN
  KNOW_TAC `(COMPL o f) IN (UNIV -> events p)` THEN1
	(RW_TAC std_ss [IN_FUNSET, IN_UNIV] THEN
	PROVE_TAC [EVENTS_COMPL]) THEN
  KNOW_TAC `(\n. sum (0,n) (prob p o (\m. f m DIFF f (SUC m)))) = 
			(\n. sum (0,n) (prob p o (\m. (COMPL o f) (SUC m) DIFF (COMPL o f) m)))` THEN1
	(ABS_TAC THEN
	MATCH_MP_TAC RAND_THM THEN
	RW_TAC std_ss [o_DEF] THEN
	ABS_TAC THEN
	MATCH_MP_TAC RAND_THM THEN
	PSET_TAC [DIFF_DEF, COMPL_DEF] THEN
	REWRITE_TAC [EXTENSION] THEN
	PSET_TAC [CONJ_COMM]) THEN
  ONCE_ASM_REWRITE_TAC [] THEN
  REWRITE_TAC [prob_def] THEN
	

   REWRITE_TAC [GSYM sums] THEN
   MATCH_MP_TAC COUNTABLY_ADDITIVE THEN
   CONJ_TAC THEN1
	PROVE_TAC [measure_space_def, events_def, prob_space_def] THEN
   CONJ_TAC THEN1
        (FULL_SIMP_TAC std_ss [IN_FUNSET, IN_UNIV] THEN
        PROVE_TAC [ALGEBRA_DIFF, measure_space_def, SIGMA_ALGEBRA_ALGEBRA, 
		events_def, prob_space_def]) THEN
   CONJ_TAC THEN1
   	(REPEAT STRIP_TAC THEN
       	MATCH_MP_TAC DISJOINT_DIFFS THEN
       	Q.EXISTS_TAC `(COMPL o f)` THEN
       	RW_TAC std_ss [events_def, prob_space_def]) THEN
   CONJ_TAC THEN1
	(NTAC 4 (POP_ASSUM MP_TAC) THEN
	Q.SPEC_TAC (`(COMPL o f)`, `g`) THEN
	PSET_TAC [EXTENSION] THEN
	REVERSE (EQ_TAC THEN RW_TAC std_ss []) THEN1
		PROVE_TAC [] THEN

    	KNOW_TAC `x IN g x'` THEN1
		PROVE_TAC [] THEN
		POP_ASSUM MP_TAC THEN
                NTAC 2 (POP_ASSUM K_TAC) THEN
		Induct_on `x'` THEN1
 	       		RW_TAC std_ss [] THEN
       	       	POP_ASSUM MP_TAC THEN
       		Cases_on `x IN g x'` THEN1 RW_TAC std_ss [] THEN
       		RW_TAC std_ss [] THEN
		Q.EXISTS_TAC `g (SUC x') DIFF g x'` THEN
       		PSET_TAC [EXTENSION] THEN
       		PROVE_TAC []) THEN
   MATCH_MP_TAC SIGMA_ALGEBRA_COUNTABLE_UNION THEN
   CONJ_TAC THEN1
	PROVE_TAC [measure_space_def, events_def, prob_space_def] THEN
   RW_TAC std_ss [COUNTABLE_IMAGE_NUM] THEN
   RW_TAC std_ss [SUBSET_DEF, IN_IMAGE, IN_UNIV] THEN
   FULL_SIMP_TAC std_ss [events_def,IN_FUNSET, IN_UNIV]);
	

val PROB_DECREASING_INTER = store_thm
  ("PROB_DECREASING_INTER",
   (--`!s f.
       (f:num -> (num -> bool) -> bool) IN (UNIV -> events bern) /\
       (!n. f (SUC n) SUBSET f n) /\
       (s = BIGINTER (IMAGE f UNIV)) ==>
       prob bern o f --> prob bern s`--),
  RW_TAC std_ss [IN_FUNSET, IN_UNIV] THEN
  (MP_TAC o
       INST_TYPE [beta |-> Type `:num`] o
       Q.SPECL [`BIGINTER (IMAGE (f:num -> (num -> bool) -> bool) UNIV)`, 
		`num_case UNIV (f:num -> (num -> bool) -> bool)`, `bern`])
      PROB_COUNTABLE_DECREASING THEN
  RW_TAC std_ss [] THEN
  KNOW_TAC `num_case UNIV (f:num -> (num -> bool) -> bool) IN (UNIV -> events bern) /\
          (!n. f n SUBSET num_case UNIV f n) /\
          (BIGINTER (IMAGE f UNIV) =
           BIGINTER (IMAGE (num_case UNIV f) UNIV))` THEN1 (
  	RW_TAC std_ss [IN_FUNSET, IN_UNIV] THENL [
  	Cases_on `x` THEN1
  		RW_TAC std_ss [num_case_def, EVENTS_BERN_UNIV] THEN
	RW_TAC std_ss [num_case_def],
	Cases_on `n` THEN1
		RW_TAC std_ss [num_case_def, EMPTY_SUBSET, SUBSET_UNIV] THEN
	RW_TAC std_ss [num_case_def],
	SET_EQ_TAC THEN
	RW_TAC std_ss [IN_BIGINTER_IMAGE, IN_UNIV] THEN
        EQ_TAC THENL [
		RW_TAC std_ss [] THEN
		Cases_on `y` THEN1
			RW_TAC std_ss [IN_UNIV] THEN
         	RW_TAC std_ss [num_case_def],
		RW_TAC std_ss [] THEN
		Cases_on `y` THENL [
			KNOW_TAC `x IN num_case UNIV f 0` THEN1
				PROVE_TAC [] THEN
			PROVE_TAC [num_case_def],
			KNOW_TAC `x IN num_case UNIV f (SUC (SUC n))` THEN1
				PROVE_TAC [] THEN
			POP_ASSUM MP_TAC THEN
			ONCE_REWRITE_TAC [num_case_def] THEN
			RW_TAC std_ss []]]]) THEN
  KNOW_TAC `prob bern o num_case UNIV  (f:num -> (num -> bool) -> bool) -->
          prob bern (BIGINTER (IMAGE (num_case UNIV f) UNIV)) ==>
          prob bern o f  --> prob bern (BIGINTER (IMAGE f UNIV))` THEN1 (
  RW_TAC std_ss [] THEN
  KNOW_TAC `prob bern o (f:num -> (num -> bool) -> bool) = 
			(\n. (prob bern o (num_case UNIV f)) (SUC n))` THEN1 (
	FUN_EQ_TAC THEN
        RW_TAC std_ss [num_case_def, o_THM]) THEN
  ASM_REWRITE_TAC [] THEN
  POP_ASSUM K_TAC THEN
  POP_ASSUM MP_TAC THEN
  KILL_ALL_TAC THEN
  Q.SPEC_TAC (`prob bern o num_case UNIV f`, `g`) THEN
  Q.SPEC_TAC (`prob bern (BIGINTER (IMAGE (num_case UNIV f) UNIV))`, `m`) THEN
  RW_TAC std_ss [GSYM SEQ_SUC]) THEN
  PROVE_TAC [PROB_SPACE_BERN]);

(*--------------
    Property 1.
--------------*)

val CDF_RANGE = store_thm
  ("CDF_RANGE",
  (--`!f x. CDF_in_events_bern f x ==>
	(0 <= CDF f x /\ CDF f x <= 1)`--),
  RW_TAC std_ss [CDF_def, CDF_in_events_bern_def, 
	PROB_POSITIVE, PROB_LE_1, PROB_SPACE_BERN, PROB]);

(*--------------
    Property 2.
--------------*)

val CDF_NON_DECREASING = store_thm
  ("CDF_NON_DECREASING",
  (--`!f a b. a < b /\ 
	(!x. CDF_in_events_bern f x) ==> (CDF f a <= CDF f b)`--),
   RW_TAC std_ss [CDF_def, CDF_in_events_bern_def] THEN
   MATCH_MP_TAC PROB_INCREASING THEN
   RW_TAC std_ss [PROB_SPACE_BERN] THEN
   REWRITE_TAC [SUBSET_DEF] THEN
   REWRITE_TAC [SPECIFICATION] THEN
   X_GEN_TAC (--`(s:num -> bool)`--) THEN 
   PSET_TAC [] THEN
   MATCH_MP_TAC REAL_LE_TRANS THEN
   EXISTS_TAC (--`a:real`--) THEN
   RW_TAC std_ss [REAL_LT_IMP_LE]);

								
							
(*--------------
    Property 3.
--------------*)
val CDF_INTERVAL_PROB = store_thm
  ("CDF_INTERVAL_PROB",
  (--`!f a b. a < b /\ 
	(!x. CDF_in_events_bern f x) ==>
		(prob bern {s | (a < f s) /\ (f s <= b)} =
			CDF f b - CDF f a)`--),
  RW_TAC std_ss [CDF_def, CDF_in_events_bern_def] THEN
  KNOW_TAC `{s | f s <= b} = {s | f s <= a} UNION {s | a < f s /\ f s <= b}` THEN1
	(RW_TAC std_ss [UNION_DEF] THEN
	REWRITE_TAC [SPECIFICATION] THEN
	PSET_TAC [] THEN
	EQ_TAC THEN1
		RW_TAC std_ss [LEFT_OR_OVER_AND, REAL_LET_TOTAL] THEN
	PROVE_TAC [REAL_LET_TRANS, REAL_LT_IMP_LE]) THEN
  ASM_REWRITE_TAC [REAL_EQ_SUB_LADD] THEN
  ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
  MATCH_MP_TAC PROB_ADDITIVE THEN
  RW_TAC std_ss [PROB_SPACE_BERN, UNION_COMM] THENL [
	KNOW_TAC `{s | a < f s /\ f s <= b} = {s | f s <= b} DIFF {s | f s <= a}` THENL [
		RW_TAC std_ss [DIFF_DEF] THEN
	REWRITE_TAC [SPECIFICATION] THEN
	PSET_TAC [] THEN
	EQ_TAC THEN
	RW_TAC std_ss [REAL_LET_TOTAL, GSYM real_lt, LEFT_OR_OVER_AND] THEN
	PROVE_TAC [REAL_LTE_TRANS],
	ONCE_ASM_REWRITE_TAC [] THEN
	MATCH_MP_TAC EVENTS_DIFF THEN
	RW_TAC std_ss [PROB_SPACE_BERN]],
	RW_TAC std_ss [DISJOINT_DEF, INTER_DEF] THEN
	REWRITE_TAC [SPECIFICATION] THEN
	PSET_TAC [GSYM real_lt] THEN
	PROVE_TAC []]);

(*----------------------------------------------------------------------------
    Property 4.: Infinity = (\n. n) tends to infinity as n approaches infinity
-----------------------------------------------------------------------------*)

val CDF_AT_POSITIVE_INFINITY = store_thm
  ("CDF_AT_POSITIVE_INFINITY",
  (--`!f. (!x. CDF_in_events_bern f x) ==>
	(\n. CDF f ((\n. &n) n)) --> 1`--),
RW_TAC std_ss [CDF_def, CDF_in_events_bern_def] THEN
KNOW_TAC `(\n. prob bern {s | f s <= & n}) = prob bern o (\n. {s | f s <= & n})` THEN1
	PSET_TAC [o_DEF] THEN
ASM_REWRITE_TAC [] THEN
REWRITE_TAC [GSYM PROB_BERN_UNIV] THEN
MATCH_MP_TAC PROB_INCREASING_UNION THEN
RW_TAC std_ss [PROB_SPACE_BERN,IN_UNIV, IN_FUNSET] THENL [
	REWRITE_TAC [SUBSET_DEF, SPECIFICATION] THEN
	PSET_TAC [] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`&n`--) THEN
	RW_TAC arith_ss [REAL_LE],

	RW_TAC std_ss [IN_BIGUNION_IMAGE, IN_UNIV, EXTENSION] THEN
	SRW_TAC [][EXTENSION] THEN
	REWRITE_TAC [REAL_LE_LT] THEN
	FULL_SIMP_TAC std_ss [EXISTS_OR_THM] THEN
	RW_TAC std_ss [] THEN
	DISJ1_TAC THEN
	MP_TAC (Q.SPEC `1` REAL_ARCH) THEN
	REWRITE_TAC [REAL_LT_01, REAL_MUL_RID] THEN
	RW_TAC std_ss []]);

(*-------------------------------------------------------------------------------
    Property 5. - Infinity = (\n. -n) tends to -infinity as n approaches infinity
---------------------------------------------------------------------------------*)

val CDF_AT_NEGETIVE_INFINITY = store_thm
  ("CDF_AT_NEGETIVE_INFINITY",
  (--`!f. (!x. CDF_in_events_bern f x) ==>
	(\n. CDF f ((\n. ~&n) n)) --> 0`--),
RW_TAC std_ss [CDF_def, CDF_in_events_bern_def] THEN
KNOW_TAC `(\n. prob bern {s | f s <= ~ & n}) = prob bern o (\n. {s | f s <= ~ & n})` THEN1
	PSET_TAC [o_DEF] THEN
ASM_REWRITE_TAC [] THEN
REWRITE_TAC [GSYM PROB_BERN_EMPTY] THEN
MATCH_MP_TAC PROB_DECREASING_INTER THEN
RW_TAC std_ss [IN_UNIV, IN_FUNSET] THENL [
	REWRITE_TAC [SUBSET_DEF, SPECIFICATION] THEN
	PSET_TAC [] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`~&(SUC n)`--) THEN
	RW_TAC arith_ss [REAL_LE, REAL_LE_NEG],

	RW_TAC std_ss [IN_BIGINTER_IMAGE, IN_UNIV, EXTENSION] THEN
	SRW_TAC [][EXTENSION] THEN
	REWRITE_TAC [GSYM real_lt] THEN
	KNOW_TAC `!a (b:real). ~a < b = ~b < a` THEN1 (
	RW_TAC std_ss [] THEN
	KNOW_TAC `~a < b = ~a + a < b + a` THEN1
	PROVE_TAC [GSYM REAL_LT_RADD] THEN
	KNOW_TAC `~b < a = ~b + b < a + b` THEN1
	PROVE_TAC [GSYM REAL_LT_RADD] THEN
	FULL_SIMP_TAC std_ss [REAL_ADD_LINV, REAL_ADD_SYM]) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	MP_TAC (Q.SPEC `1` REAL_ARCH) THEN
	REWRITE_TAC [REAL_LT_01, REAL_MUL_RID] THEN
	RW_TAC std_ss []]);

(*--------------------------------------
    Property 6. CDF continuous from right
----------------------------------------*)

val CDF_CONT_RIGHT = store_thm
  ("CDF_CONT_RIGHT",
  (--`!f a. (!x. CDF_in_events_bern f x) ==>
	(\n. CDF f ((\n. a + (inv (& (SUC n)))) n)) --> CDF f a`--),
RW_TAC std_ss [CDF_def, CDF_in_events_bern_def] THEN
KNOW_TAC `(\n. prob bern {s | f s <= a + inv (&(SUC n))}) = 
			prob bern o (\n. {s | f s <= a + inv (&(SUC n))})` THEN1
	PSET_TAC [o_DEF] THEN
ASM_REWRITE_TAC [] THEN
MATCH_MP_TAC PROB_DECREASING_INTER THEN
RW_TAC std_ss [IN_UNIV, IN_FUNSET] THENL [
	REWRITE_TAC [SUBSET_DEF, SPECIFICATION] THEN
	PSET_TAC [] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`a + inv (&(SUC (SUC n)))`--) THEN
	RW_TAC std_ss [REAL_LE_LADD] THEN
	MATCH_MP_TAC REAL_LE_INV_LE THEN
	RW_TAC arith_ss [REAL_LE, REAL_LT],

	RW_TAC std_ss [IN_BIGINTER_IMAGE, IN_UNIV, EXTENSION] THEN
	PSET_TAC [] THEN
	EQ_TAC THENL [
		REPEAT STRIP_TAC THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`(a:real)`--) THEN
		RW_TAC real_ss [REAL_LE_ADDR, INV_SUC, GSYM real_div, REAL_LT_IMP_LE],
		REPEAT STRIP_TAC THEN
		MATCH_MP_TAC LE_SEQ_IMP_LE_LIM THEN
		EXISTS_TAC (--`(\n. a + inv (& (SUC n)))`--) THEN
		RW_TAC std_ss [] THEN
		KNOW_TAC `a = a + 0` THEN1
			RW_TAC real_ss [] THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		KNOW_TAC `(\n. a + 0 + inv (& (SUC n))) = (\n. (\n. a) n + (\n. inv (& (SUC n))) n)` THEN1
			RW_TAC real_ss [SEQ_CONST] THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC SEQ_ADD THEN
		RW_TAC real_ss [SEQ_CONST] THEN
		KNOW_TAC `(\n. inv (& (SUC n))) = (\n. inv ((\n. & (SUC n)) n))` THEN1
			RW_TAC std_ss [] THEN 
		ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC SEQ_INV0 THEN
		GEN_TAC THEN
		EXISTS_TAC (--`ceiling y`--) THEN
		RW_TAC std_ss [real_gt] THEN
		MATCH_MP_TAC REAL_LET_TRANS THEN
		EXISTS_TAC (--`&n`--) THEN
		RW_TAC arith_ss [REAL_LT] THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`&(ceiling y)`--) THEN
		RW_TAC std_ss [LB_CEILING, GSYM GREATER_EQ, REAL_LE]]]);


(*--------------------------------------
    Property 7. CDF limit from left
----------------------------------------*)
val CDF_LIMIT_FROM_LEFT = store_thm
  ("CDF_LIMIT_FROM_LEFT",
  (--`!f a. (!x. CDF_in_events_bern f x) ==>
	((\n. CDF f ((\n. a - (inv (& (SUC n)))) n)) --> (prob bern {s | f s < a}))`--),
RW_TAC std_ss [CDF_def, CDF_in_events_bern_def] THEN
KNOW_TAC `(\n. prob bern {s | f s <= a - inv (& (SUC n))}) = 
			prob bern o (\n. {s | f s <= a - inv (& (SUC n))})` THEN1
	PSET_TAC [o_DEF] THEN
ASM_REWRITE_TAC [] THEN
MATCH_MP_TAC PROB_INCREASING_UNION THEN
RW_TAC std_ss [IN_UNIV, IN_FUNSET, PROB_SPACE_BERN] THENL [
	REWRITE_TAC [SUBSET_DEF, SPECIFICATION] THEN
	PSET_TAC [] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`a - inv (& (SUC n))`--) THEN
	RW_TAC std_ss [REAL_LE_SUB_LADD] THEN
	KNOW_TAC `!a b c. a - b + c = a + c - b` THEN1 REAL_ARITH_TAC THEN
	FULL_SIMP_TAC std_ss [] THEN
	REWRITE_TAC [REAL_LE_SUB_RADD, REAL_LE_LADD] THEN
	MATCH_MP_TAC REAL_LE_INV_LE THEN
	RW_TAC arith_ss [REAL_LE, REAL_LT],
	
	RW_TAC std_ss [IN_BIGUNION_IMAGE, IN_UNIV, EXTENSION] THEN
	PSET_TAC [] THEN
	EQ_TAC THENL [
		REPEAT STRIP_TAC THEN		
		CCONTR_TAC THEN
		FULL_SIMP_TAC std_ss [NOT_EXISTS_THM, REAL_NOT_LE] THEN
		KNOW_TAC `a <= f x` THENL [
			MATCH_MP_TAC SEQ_LE_IMP_LIM_LE THEN
			EXISTS_TAC (--`(\n. a - inv (& (SUC n)))`--) THEN
			RW_TAC std_ss [REAL_LT_IMP_LE] THEN
		
			KNOW_TAC `a = a - 0` THEN1
				RW_TAC real_ss [] THEN
			ONCE_ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			KNOW_TAC `(\n. a - 0 - inv (& (SUC n))) = 
				(\n. (\n. a) n - (\n. inv (& (SUC n))) n)` THEN1
				RW_TAC real_ss [SEQ_CONST] THEN
			ONCE_ASM_REWRITE_TAC [] THEN
			MATCH_MP_TAC SEQ_SUB THEN
			RW_TAC real_ss [SEQ_CONST] THEN
			KNOW_TAC `(\n. inv (& (SUC n))) = (\n. inv ((\n. & (SUC n)) n))` THEN1
				RW_TAC std_ss [] THEN 
			ASM_REWRITE_TAC [] THEN
			MATCH_MP_TAC SEQ_INV0 THEN
			GEN_TAC THEN
			EXISTS_TAC (--`ceiling y`--) THEN
			RW_TAC std_ss [real_gt] THEN
			MATCH_MP_TAC REAL_LET_TRANS THEN
			EXISTS_TAC (--`&n`--) THEN
			RW_TAC arith_ss [REAL_LT] THEN
			MATCH_MP_TAC REAL_LE_TRANS THEN
			EXISTS_TAC (--`&(ceiling y)`--) THEN
			RW_TAC std_ss [LB_CEILING, GSYM GREATER_EQ, REAL_LE],
		
			FULL_SIMP_TAC std_ss [real_lt]],

		RW_TAC std_ss [] THEN
		MATCH_MP_TAC REAL_LET_TRANS THEN
		EXISTS_TAC (--`a - inv (& (SUC n))`--) THEN
		RW_TAC real_ss [REAL_LT_SUB_RADD, GSYM real_div, REAL_LT_ADDR, INV_SUC_POS]]]);

(*--------------------------------------
    Continuous r.v. CDF Properties
----------------------------------------*)

val PROB_EQ_SUBSET = store_thm
   ("PROB_EQ_SUBSET",
   (--`!f a. {s | f s = a} SUBSET 
	{s | ((a - inv (& (SUC n))) < f s) /\ (f s <= a)}`--),
	PSET_TAC [SUBSET_DEF, GSPECIFICATION, REAL_LE_REFL, 
	REAL_MUL_LID, REAL_LT, REAL_LT_SUB_RADD, REAL_LT_ADDR, 
	real_div, REAL_LT_INV_EQ] THEN
	DECIDE_TAC);

val CONT_CDF_CONT_LEFT = store_thm
  ("CONT_CDF_CONT_LEFT",
  (--`!f a. (!x. CDF_in_events_bern f x) /\ (!x. (\x. CDF f x) contl x) ==>
	((\n. CDF f (a - (inv (& (SUC n))))) --> (CDF f a))`--),
   RW_TAC std_ss [SEQ, LIM, contl] THEN
   POP_ASSUM MP_TAC THEN
   POP_ASSUM (MP_TAC o Q.SPECL [`a`, `e`]) THEN
   RW_TAC real_ss [] THEN
   FULL_SIMP_TAC std_ss [] THEN
   EXISTS_TAC (--`(ceiling (inv d))`--) THEN
   RW_TAC std_ss [] THEN
   KNOW_TAC `0 < abs (~inv (& (SUC n)))` THEN1 (
	RW_TAC std_ss [ABS_NEG] THEN
	REWRITE_TAC [GSYM ABS_NZ] THEN
	REWRITE_TAC [REAL_NE_LT_GT] THEN
	DISJ2_TAC THEN
	MATCH_MP_TAC REAL_INV_POS THEN
	RW_TAC arith_ss [REAL_LT]) THEN
   KNOW_TAC `abs (~inv (& (SUC n))) < d` THEN1 (
	RW_TAC std_ss [ABS_NEG] THEN
	KNOW_TAC `0 <= (inv (& (SUC n)))` THEN1 (
		MATCH_MP_TAC REAL_LT_IMP_LE THEN	
		MATCH_MP_TAC REAL_INV_POS THEN
		RW_TAC arith_ss [REAL_LT]) THEN
	KNOW_TAC `abs (inv (& (SUC n))) = (inv (& (SUC n)))` THEN1
		RW_TAC std_ss [ABS_REFL] THEN
	ASM_REWRITE_TAC [] THEN
	MATCH_MP_TAC REAL_LET_TRANS THEN
	EXISTS_TAC (--`1 * inv (& (SUC n))`--) THEN
	CONJ_TAC THEN1
		RW_TAC real_ss [] THEN
		REWRITE_TAC [GSYM real_div] THEN
		RW_TAC arith_ss [REAL_LT, REAL_LT_LDIV_EQ, ADD1,  
			GSYM REAL_ADD, REAL_ADD_LDISTRIB, REAL_MUL_RID] THEN
		MATCH_MP_TAC REAL_LTE_TRANS THEN
		EXISTS_TAC (--`d * & (ceiling (inv d)) + d`--) THEN
		FULL_SIMP_TAC std_ss [REAL_LE_RADD, REAL_LE_LMUL, REAL_LE, GREATER_EQ] THEN
		MATCH_MP_TAC REAL_LTE_TRANS THEN
		EXISTS_TAC (--`d * (inv d) + d`--) THEN
		FULL_SIMP_TAC real_ss [REAL_LE_RADD, REAL_LE_LMUL, LB_CEILING] THEN
		KNOW_TAC `~(d = 0)` THEN1
			RW_TAC std_ss [REAL_NE_LT_GT ] THEN
		RW_TAC std_ss [REAL_MUL_RINV, REAL_LT_ADDR]) THEN
KNOW_TAC `(a - inv (& (SUC n))) = (a + ~inv (& (SUC n)))` THEN1
	RW_TAC std_ss [GSYM real_sub] THEN
PROVE_TAC []);


val CONT_CDF_EQ_PROB_BERN_LT = store_thm
  ("CONT_CDF_EQ_PROB_BERN_LT",
  (--`!f a.(!x. CDF_in_events_bern f x) /\ 
	(!x. (\x. CDF f x) contl x) ==>
	(CDF f a = prob bern {s | f s < a})`--),
RW_TAC std_ss [] THEN
MATCH_MP_TAC SEQ_UNIQ THEN
EXISTS_TAC (--`(\n. CDF f (a - (inv (& (SUC n)))))`--) THEN
MP_TAC CDF_LIMIT_FROM_LEFT THEN
FULL_SIMP_TAC std_ss [CONT_CDF_CONT_LEFT]);


val CONT_PROB_BERN_EQ_0 = store_thm
  ("CONT_PROB_BERN_EQ_0",
  (--`!f a.(!x. CDF_in_events_bern f x) /\ 
	(!x. {s | f s = x} IN events bern) /\
	(!x. (\x. CDF f x) contl x) ==>
	(prob bern {s | f s = a} = 0)`--),
RW_TAC std_ss [] THEN
KNOW_TAC `prob bern {s |f s <= a} = 
	prob bern {s | f s < a} + prob bern {s | f s = a}` THENL [
MATCH_MP_TAC PROB_ADDITIVE THEN
RW_TAC std_ss [PROB_SPACE_BERN] THENL [
	KNOW_TAC `{s | f s < a} = {s | f s <= a} DIFF {s | f s = a}` THEN1 (
		PSET_TAC [DIFF_DEF] THEN
		RW_TAC std_ss [REAL_LE_LT, RIGHT_AND_OVER_OR] THEN
		RW_TAC std_ss [REAL_NE_LT_GT, LEFT_AND_OVER_OR, REAL_LT_ANTISYM]) THEN
	ASM_REWRITE_TAC [] THEN
	MATCH_MP_TAC EVENTS_DIFF THEN
	RW_TAC std_ss [PROB_SPACE_BERN, GSYM CDF_in_events_bern_def],
	
	PSET_TAC [DISJOINT_DEF] THEN
	PROVE_TAC [REAL_NE_LT_GT, GSYM DISJ_ASSOC, REAL_NOT_LT, REAL_LET_TOTAL],
	
	PSET_TAC [UNION_DEF, REAL_LE_LT]],
POP_ASSUM MP_TAC THEN
ONCE_REWRITE_TAC [REAL_ADD_COMM] THEN
FULL_SIMP_TAC real_ss [GSYM CONT_CDF_EQ_PROB_BERN_LT, CDF_def, GSYM REAL_EQ_SUB_RADD]]);

val CONT_CDF_EXISTS_GT0_LT1 = store_thm
   ("CONT_CDF_EXISTS_GT0_LT1",
   (--`!f y. (!x. CDF_in_events_bern f x) /\
         (!x. (\x. CDF f x) contl x) ==>
	(?y. (0 < CDF f y) /\ (CDF f y < 1))`--),
	RW_TAC std_ss [] THEN 
	MP_TAC (Q.SPEC `f` CDF_AT_POSITIVE_INFINITY) THEN
	MP_TAC (Q.SPEC `f` CDF_AT_NEGETIVE_INFINITY) THEN
	RW_TAC std_ss [] THEN
	FULL_SIMP_TAC std_ss [SEQ] THEN
	POP_ASSUM (MP_TAC o Q.SPEC `1`) THEN
	RW_TAC real_ss [] THEN
	POP_ASSUM (MP_TAC o Q.SPEC `SUC N`) THEN
	RW_TAC real_ss [GSYM ABS_BETWEEN, REAL_SUB_SUB2, REAL_SUB_LT] THEN
	POP_ASSUM K_TAC THEN
	POP_ASSUM MP_TAC THEN
	POP_ASSUM (MP_TAC o Q.SPEC `1`) THEN
	RW_TAC real_ss [] THEN
	POP_ASSUM MP_TAC THEN
	POP_ASSUM (MP_TAC o Q.SPEC `SUC N'`) THEN
	KNOW_TAC `!x. (abs (CDF f x) = CDF f x)` THEN1
        	RW_TAC std_ss [ABS_REFL, CDF_RANGE] THEN
	RW_TAC real_ss [REAL_SUB_LT] THEN
	KNOW_TAC `~& (SUC N') < (& (SUC N))` THEN1
		RW_TAC arith_ss [lt_int] THEN
	KNOW_TAC `CDF f (~& (SUC N')) <= CDF f (& (SUC N))` THEN1
		RW_TAC std_ss [CDF_NON_DECREASING] THEN
	POP_ASSUM MP_TAC THEN
	RW_TAC std_ss [REAL_LE_LT] THENL [
		Cases_on `CDF f ~& (SUC N') < 0` THEN1
			PROVE_TAC [CDF_RANGE, REAL_NOT_LE] THEN
		FULL_SIMP_TAC std_ss [REAL_NOT_LT] THEN
		POP_ASSUM MP_TAC THEN
		RW_TAC std_ss [REAL_LE_LT] THEN1 (
			EXISTS_TAC (--`~& (SUC N')`--) THEN
			PROVE_TAC []) THEN
		POP_ASSUM MP_TAC THEN
		ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
		Cases_on `1 < CDF f (& (SUC N))` THEN1
			PROVE_TAC [CDF_RANGE, REAL_NOT_LE] THEN
		FULL_SIMP_TAC std_ss [REAL_NOT_LT] THEN
		POP_ASSUM MP_TAC THEN
		RW_TAC std_ss [REAL_LE_LT] THEN1 (
			EXISTS_TAC (--`& (SUC N)`--) THEN
			PROVE_TAC []) THEN
		MP_TAC (Q.SPECL [`(\x. CDF f x)`, `~& (SUC N')`, 
				`(& (SUC N))`, `1 / 2`] IVT) THEN
		RW_TAC real_ss [REAL_EQ_IMP_LE, REAL_LT_IMP_LE] THEN
		EXISTS_TAC (--`x:real`--) THEN
		RW_TAC real_ss [],

		EXISTS_TAC (--`~& (SUC N')`--) THEN
		PROVE_TAC []]);

val _ = export_theory();
