(* loadPath := "/nfs/thesis/o/o_hasan/hol/cont_prob_dist/miller" ::
!loadPath;

app load ["HolKernel", "Parse", "boolLib", "bossLib", "arithmeticTheory",
     "pred_setTheory", "listTheory", "sequenceTheory", "state_transformerTheory",
     "probabilityTheory", "formalizeUseful", "extra_numTheory", "combinTheory",
     "pairTheory", "realTheory", "realLib", "extra_boolTheory", "jrhUtils",
     "extra_pred_setTheory", "prob_algebraTheory", "probTheory", "realSimps",
     "extra_realTheory", "extra_pred_setTools", "measureTheory", "numTheory",
     "simpLib", "prob_extraTheory", "probTools", "prob_extraTools", "pred_setLib",
     "subtypeTheory", "probdec_interTheory", "seqTheory", "std_unifTheory",
     "prob_bernoulliTheory", "binomialTheory"]; 

*)
open HolKernel Parse boolLib bossLib arithmeticTheory pred_setTheory
     listTheory sequenceTheory state_transformerTheory
     probabilityTheory formalizeUseful extra_numTheory combinTheory
     pairTheory realTheory realLib extra_boolTheory jrhUtils
     extra_pred_setTheory prob_algebraTheory probTheory realSimps
     extra_realTheory extra_pred_setTools measureTheory numTheory
     simpLib prob_extraTheory probTools prob_extraTools pred_setLib
     subtypeTheory seqTheory std_unifTheory
     prob_bernoulliTheory binomialTheory;

val _ = new_theory "prob_bernoulli_p";


val std_ss' = simpLib.++ (std_ss, boolSimps.ETA_ss);

val prob_binomial_p_def = Define
  `(prob_binomial_p 0 p = UNIT 0) /\
   (prob_binomial_p (SUC n) p =
    BIND (prob_binomial_p n p)
    (\m. BIND (prob_bernoulli p) (\b. UNIT (if b then SUC m else m))))`;


val INDEP_FN_PROB_BINOMIAL_P = store_thm
  ("INDEP_FN_PROB_BINOMIAL_P",
   (--`!n p. prob_binomial_p n p IN indep_fn`--),
   Induct THEN1
	RW_TAC std_ss [prob_binomial_p_def, INDEP_FN_UNIT] THEN
   RW_TAC std_ss [prob_binomial_p_def, INDEP_FN_UNIT, INDEP_FN_BIND, 
			INDEP_FN_PROB_BERNOULLI]);

val PROB_BERN_BIND_BERNOULLI_P = store_thm
  ("PROB_BERN_BIND_BERNOULLI_P",
   (--`!f p q.
       (!x. f x IN indep_fn) /\ 0 <= p /\ p <= 1 ==>
       (prob bern (q o FST o BIND (prob_bernoulli p) f) =
        p * prob bern (q o FST o f T) +
        (1 - p) * prob bern (q o FST o f F))`--),
   RW_TAC std_ss [] THEN
   MP_TAC (Q.SPECL [`(prob_bernoulli p)`, `f`, `p`, `q`] PROB_BERN_BIND_BOOL) THEN
   KNOW_TAC `(FST o prob_bernoulli p) = {s | FST (prob_bernoulli p s)}` THEN1
	PSET_TAC [GSPECIFICATION, o_THM] THEN
   RW_TAC std_ss [INDEP_FN_SDEST, PROB_BERN_HALFSPACE, ONE_MINUS_HALF,
		PROB_BERNOULLI, INDEP_FN_PROB_BERNOULLI]);
  
	 
val PROB_BERN_BINOMIAL_P = store_thm
  ("PROB_BERN_BINOMIAL_P",
   (--`!n m p. 0 <= p /\ p <= 1 ==> 
       (prob bern {s | FST (prob_binomial_p n p s) = m} =
       &(binomial n m) * (p pow m) * ((1 - p) pow (n - m)))`--),
Induct THEN1 (
	Cases THEN
		RW_TAC arith_ss [prob_binomial_p_def, UNIT_DEF, binomial_def,
			GEMPTY, GUNIV, PROB_BERN_BASIC, pow, REAL_OVER1,
			REAL_DIV_LZERO, REAL_MUL_LID, REAL_MUL_LZERO]) THEN
	
			
   	RW_TAC arith_ss [prob_binomial_p_def] THEN
        KNOW_TAC `{s |
        	FST (BIND (prob_binomial_p n p)
         		(\m. BIND (prob_bernoulli p)
				(\b. UNIT (if b then SUC m else m))) s) = m} =
       		($= m) o FST o BIND (prob_binomial_p n p)
       			(\m. BIND (prob_bernoulli p) 
			(\b. UNIT (if b then SUC m else m)))` THEN1 (
   		SET_EQ_TAC THEN
       		RW_TAC std_ss [GSPECIFICATION] THEN
       		RW_TAC std_ss [SPECIFICATION, o_THM] THEN
       		PROVE_TAC []) THEN
   	ASM_REWRITE_TAC [] THEN
   	KNOW_TAC `prob bern
		($= m o FST o BIND (prob_binomial_p n p)
       			(\m. BIND (prob_bernoulli p) 
			(\b. UNIT (if b then SUC m else m)))) =
       			prob bern
       			($= m o FST o
        			BIND (prob_bernoulli p)
        			(\b. BIND (prob_binomial_p n p) 
				(\m. UNIT (if b then SUC m else m))))` THEN1 (
   		HO_MATCH_MP_TAC PROB_BERN_BIND_COMM THEN
       		RW_TAC std_ss [INDEP_FN_PROB_BINOMIAL_P, 
			INDEP_FN_SDEST, INDEP_FN_UNIT, INDEP_FN_PROB_BERNOULLI]) THEN
   	ASM_REWRITE_TAC [] THEN
   	RW_TAC std_ss [PROB_BERN_BIND_BERNOULLI_P, INDEP_FN_BIND, INDEP_FN_UNIT,
                      INDEP_FN_PROB_BINOMIAL_P, BIND_RIGHT_UNIT] THEN

	KNOW_TAC 
      		`($= m o FST o BIND (prob_binomial_p n p) (\m. UNIT (SUC m))) =
       					((\x. m = SUC x) o FST o prob_binomial_p n p)` THEN1 (
   		FUN_EQ_TAC THEN
       		RW_TAC std_ss [o_THM, BIND_DEF, UNIT_DEF, UNCURRY]) THEN
  	ASM_REWRITE_TAC [] THEN 
   	POP_ASSUM MP_TAC THEN
        KNOW_TAC `!m. {s | FST (prob_binomial_p n p s) = m} =
			($= m o FST o (prob_binomial_p n p))` THEN1
   		(SET_EQ_TAC THEN
       		RW_TAC std_ss [GSPECIFICATION] THEN
       		RW_TAC std_ss [SPECIFICATION, o_THM] THEN
       		PROVE_TAC [EQ_SYM_EQ]) THEN
  	ASM_REWRITE_TAC [] THEN 
   	STRIP_TAC THEN
	RW_TAC std_ss [o_THM, BIND_DEF, UNIT_DEF, UNCURRY] THEN
   	Cases_on `m` THEN1 (
   		KNOW_TAC `!m. (\x. m = FST (prob_binomial_p n p x)) =
				{s | FST (prob_binomial_p n p s) = m}` THEN1
			PSET_TAC [GSPECIFICATION] THEN
			
		RW_TAC arith_ss [binomial_def, o_DEF, pow, GSYM EMPTY_DEF,
                        PROB_BERN_EMPTY, BIND_RIGHT_UNIT] THEN
		FULL_SIMP_TAC std_ss [EQ_SYM_EQ, UNCURRY] THEN
		Cases_on `n` THEN
       		RW_TAC real_ss [binomial_def]) THEN

   	RW_TAC std_ss' [binomial_def, pow, GSYM REAL_ADD, REAL_ADD_RDISTRIB] THEN
	KNOW_TAC `($= (SUC n') o FST o UNCURRY $, o prob_binomial_p n p) =
		{s | FST (prob_binomial_p n p s) = SUC n'}` THEN1 (
		REWRITE_TAC [BIND_DEF] THEN
		KILL_ALL_TAC THEN
		PSET_TAC [GSPECIFICATION] THEN
		REWRITE_TAC [o_THM] THEN
		REWRITE_TAC [UNCURRY] THEN
		PROVE_TAC [EQ_SYM_EQ]) THEN

	KNOW_TAC `p * prob bern ($= n' o FST o prob_binomial_p n p) = 
			p * prob bern {s | FST (prob_binomial_p n p s) = n'}` THEN1
		(ONCE_ASM_REWRITE_TAC [] THEN
		PROVE_TAC []) THEN

	ONCE_ASM_REWRITE_TAC [] THEN
        NTAC 4 (POP_ASSUM K_TAC) THEN
	FULL_SIMP_TAC std_ss' [binomial_def, pow, GSYM REAL_ADD] THEN
	RW_TAC real_ss [GSYM REAL_ADD] THEN
   	KNOW_TAC `(1 - p) * 
		(& (binomial n (SUC n')) * (p * p pow n') * 
		 (1 - p) pow (n - SUC n')) = 
			& (binomial n (SUC n')) * (p * p pow n') * 
			(1 - p) pow (n - n')` THEN1 (
		KNOW_TAC `(1 - p) * (& (binomial n (SUC n')) * 
				     (p * p pow n') * (1 - p) pow (n - SUC n')) = 
			(& (binomial n (SUC n')) * (p * p pow n') * 
			 (1 - p) * (1 - p) pow (n - SUC n'))` THEN1
			REAL_ARITH_TAC THEN
		ASM_REWRITE_TAC [] THEN
		Cases_on `n < SUC n'` THEN1
				    RW_TAC real_ss [BINOMIAL_DEF2] THEN
		FULL_SIMP_TAC std_ss [NOT_LESS] THEN
		KNOW_TAC `(1 - p) * (1 - p) pow (n - SUC n') =
		                (1 - p) pow (n - n')` THEN1 
		        FULL_SIMP_TAC real_ss [GSYM pow, GSYM REAL_ADD, ADD1] THEN
		ASM_REWRITE_TAC [GSYM REAL_MUL_ASSOC]) THEN						
	ASM_REWRITE_TAC [] THEN
	REAL_ARITH_TAC);


val BINOMIAL_P_UBOUND = store_thm
  ("BINOMIAL_P_UBOUND",
   (--`!n p. (\n. FST (prob_binomial_p n p s)) n  <= n`--),
RW_TAC std_ss [] THEN
Induct_on `n` THEN1   
RW_TAC std_ss [prob_binomial_p_def, UNIT_DEF, REAL_LE_REFL] THEN
RW_TAC arith_ss [prob_binomial_p_def, UNIT_DEF, BIND_DEF, UNCURRY] THEN
MATCH_MP_TAC LESS_EQ_TRANS THEN
EXISTS_TAC (--`n : num`--) THEN
RW_TAC arith_ss []);

val BINOMIAL_P_MONOSUC = store_thm
  ("BINOMIAL_P_MONOSUC",
   (--`!n p. (\n. FST (prob_binomial_p n p s)) n <= 
             (\n. FST (prob_binomial_p n p s)) (SUC n)`--),
RW_TAC arith_ss [prob_binomial_p_def, UNIT_DEF, BIND_DEF, UNCURRY]);

val BINOMIAL_P_MONO = store_thm
  ("BINOMIAL_P_MONO",
   (--`!m n p. m <= n ==> (\n. FST (prob_binomial_p n p s)) m <= 
             (\n. FST (prob_binomial_p n p s)) n`--),
Induct THEN1
    RW_TAC arith_ss [prob_binomial_p_def, UNIT_DEF, BIND_DEF, UNCURRY] THEN
Induct THEN1
    RW_TAC arith_ss [prob_binomial_p_def, UNIT_DEF, BIND_DEF, UNCURRY] THEN
GEN_TAC THEN
RW_TAC std_ss [LESS_OR_EQ] THEN
REWRITE_TAC [GSYM LESS_OR_EQ] THEN
FULL_SIMP_TAC arith_ss [] THEN
MATCH_MP_TAC LESS_EQ_TRANS THEN
EXISTS_TAC (--`(FST (prob_binomial_p n p s))`--) THEN
PROVE_TAC [BINOMIAL_P_MONOSUC]);


val BINOMIAL_P_EQ_EVENTS = store_thm
  ("BINOMIAL_P_EQ_EVENTS",
 (--`!n p m. {s | FST (prob_binomial_p n p s) = m} IN events bern`--),
     REPEAT GEN_TAC  THEN
     KNOW_TAC  `{s | FST (prob_binomial_p n p s) = m} =
        ((\y. y = m) o FST o prob_binomial_p n p)` THEN1
	PSET_TAC [o_DEF] THEN
     ASM_REWRITE_TAC [] THEN
     MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
     RW_TAC std_ss [INDEP_FN_PROB_BINOMIAL_P]);


val _ = export_theory();








